<template>
    <div>
        <div class="section">
            <h1>My Templates</h1>
            <div v-if="MyLoaded">
                <div v-if="HaveMy">
                    <TemplateSearchResult v-for="template in MyTemplates" :template-value="template" :key="template.unique_key"></TemplateSearchResult>
                </div>
                <div v-else class="no-star">
                    You have not created any templates. <br>
                    Look at our
                    <router-link to="/search/Template/">get started</router-link>
                    to quickly
                    create your first template?
                </div>
            </div>
            <div class='error' v-else-if="MyError">
                Oops, something went wrong :<
            </div>
            <div v-else>
                <Loader :s="120" class="load"></Loader>

            </div>

        </div>
        <div class="section">
            <h1>Starred Templates</h1>
            <div v-if="StarLoaded">
                <div v-if="HaveStar">
                    <TemplateSearchResult v-for="template in StarTemplates" :template-value="template" :key="template.unique_key"></TemplateSearchResult>
                </div>
                <div v-else class="no-star">
                    You have no starred templates.
                    <router-link to="/search/Template/">Browse for some?</router-link>
                </div>
            </div>
            <div class='error' v-else-if="StarError">
                Oops, something went wrong :<
            </div>
            <div v-else>
                <Loader :s="120" class="load"></Loader>
            </div>
        </div>
    </div>
</template>

<style lang='scss' scoped>
    .no-star {
        font-family: Roboto, sans-serif;
        font-size: 20px;
        text-align: center;
        padding: 50px;

        a {
            text-decoration: underline;
        }
    }

    .load {
        width: 100%;
        height: 30vh;
    }

    h1 {
        display: block;
        position: relative;
        font-family: Raleway, sans-serif;
        font-weight: 800;
        font-size: 25px;
        margin: 10px 0;
    }

    .section {
        position: relative;
        padding: 30px;
        background: #eeeeee;
        margin: 20px 0;
        border-radius: 10px;
    }
</style>

<script lang='ts'>
	import {Component, Vue} from 'vue-property-decorator';
	import TemplateSearchResult from "../Search/TemplateSearchResult.vue";
	import {TemplateFlyWeight} from "../../../../classLibrary/TemplateFlyWeight";
	import Loader from "../../components/Loader.vue";
	import {CyanPrintSDK} from "../../../../classLibrary/CyanPrintSDK";
	
	@Component({components: {TemplateSearchResult, Loader}})
	export default class ProfileTemplate extends Vue {
		private myTemplates: TemplateFlyWeight[] = [];
		private starTemplates: TemplateFlyWeight[] = [];
		private myLoaded: boolean = false;
		private starLoaded: boolean = false;
		private myError: boolean = false;
		private starError: boolean = false;

		get MyLoaded(): boolean { return this.myLoaded; }

		get StarLoaded(): boolean { return this.starLoaded; }

		get MyError(): boolean { return this.myError; }

		get StarError(): boolean { return this.starError; }

		get HaveStar(): boolean { return this.starTemplates.length > 0; }

		get HaveMy(): boolean { return this.myTemplates.length > 0; }

		get MyTemplates(): TemplateFlyWeight[] {
			return this.myTemplates;
		}

		get StarTemplates(): TemplateFlyWeight[] {
			return this.starTemplates;
		}

		async mounted() {
			await Promise.all([
				this.LoadMyTemplate(),
				this.LoadStarTemplate()
			]);
		}

		async LoadStarTemplate(): Promise<void> {
			const template = await this.$api.GetUserStarredTemplate();
			if (template as any === CyanPrintSDK.error) {
				this.starError = true;
			} else {
				this.starTemplates = template;
				this.starLoaded = true;
			}
		}

		async LoadMyTemplate(): Promise<void> {
			const template = await this.$api.GetUserTemplate();
			if (template as any === CyanPrintSDK.error) {
				this.myError = true;
			} else {
				this.myTemplates = template;
				this.myLoaded = true;
			}
		}

	}
</script>
